﻿
using System;
using System.Collections.Generic;
using System.Linq;

using Demo.Data.LocalData;
using Demo.Domain.Models;

namespace Demo.Data.Repository
{
    public class UserRepositoryImpl
    {
        private List<User> _users = LocalStaticData.Users.Select(it => new User { FIO = it.FIO, Group = new Group(), Guid = it.Guid }).ToList();
        public UserRepositoryImpl() { _users = LocalStaticData.Users.Select(it => new User { FIO = it.FIO, Group = new Group(), Guid = it.Guid}).ToList(); }

        public List<User> GetAllUsers()
        {
            return _users;
        }

        public User GetByGuid(Guid id)
        {
            return _users.FirstOrDefault(static u => u.Guid  ==u.Guid);
        }

        public void AddUser(User user)
        {
            _users.Add(user);
        }

        public bool UpdateUser(User user)
        {
            var existingUser = _users.FirstOrDefault(u => u.Guid == user.Guid);
            if (existingUser != null)
            {
                existingUser.FIO = user.FIO; // Обновите остальные поля, если необходимо
                return true; // Успешное обновление
            }
            return false; // Пользователь не найден
        }


        public void RemoveUser(Guid userGuid)
        {
            var user = _users.FirstOrDefault(u => u.Guid == userGuid);
            if (user != null)
            {
                _users.Remove(user);
            }
        }

        public bool RemoveUserByGuid(Guid userGuid)
        {
            var user = _users.FirstOrDefault(u => u.Guid == userGuid);
            if (user != null)
            {
                _users.Remove(user);
                return true; // Успешное удаление
            }
            return false; // Пользователь не найден
        }

        public User FindUserByGuid(Guid userGuid) // Реализуем метод
        {
            return _users.FirstOrDefault(u => u.Guid == userGuid);
        }
    }
}
